Description: Port to GSettings.
Bug-Debian: https://bugs.debian.org/886058
Author: Yavor Doganov <yavor@gnu.org>
Forwarded: no
Last-Update: 2018-10-23
---

--- morla-0.16.1.orig/configure.ac
+++ morla-0.16.1/configure.ac
@@ -36,16 +36,6 @@
 
 AM_GLIB_DEFINE_LOCALEDIR(LOCALEDIR)
 
-AC_ARG_WITH(gconf, AC_HELP_STRING([--with-gconf=none|auto (default=auto)],[do you want gconf?]), GCONF=$withval, GCONF=auto)
-
-PKG_CHECK_MODULES(gconf, [
-  gconf-2.0 >= 2.10.0
-], gconf="gconf-2.0 >= 2.10.0", gconf="")
-
-if test "$GCONF" = none; then
-  gconf=""
-fi
-
 AC_ARG_WITH(gtkhtml, AC_HELP_STRING([--with-gtkhtml=none|auto (default=auto)],[do you want gtkhtml?]), GTKHTML=$withval, GTKHTML=auto)
 
 PKG_CHECK_MODULES(gtkhtml, [
@@ -64,20 +54,14 @@
   libxslt > 1.0.0
   nxml >= 0.18.0
   libcurl >= 7.15.0
-  $gconf
   $gtkhtml
 ])
 
 LDFLAGS="$LDFLAGS $gtk_LIBS"
 CFLAGS="$CFLAGS $gtk_CFLAGS"
 
-AH_TEMPLATE([USE_GCONF], [Define to 1 if we can use libgconf])
 AH_TEMPLATE([USE_GTKHTML], [Define to 1 if we can use gtkhtml])
 
-if test "$gconf" != ""; then
-  AC_DEFINE(USE_GCONF)
-fi
-
 if test "$gtkhtml" != ""; then
   AC_DEFINE(USE_GTKHTML)
 fi
@@ -255,7 +239,6 @@
 
   Dot (graphviz)          : $dot
   Javascript engine       : $JAVASCRIPT
-  GConf                   : $gconf
   GtkHtml                 : $gtkhtml
 
   $IGE_MAC_INTERATION
--- morla-0.16.1.orig/src/download.c
+++ morla-0.16.1/src/download.c
@@ -31,9 +31,7 @@
 gchar *download_proxy_user = NULL;
 gchar *download_proxy_password = NULL;
 
-#ifdef USE_GCONF
 gboolean download_proxy_gconf = TRUE;
-#endif
 
 struct download_mem_t
 {
@@ -80,21 +78,21 @@
       curl_easy_setopt (curl, CURLOPT_HTTPHEADER, slist);
     }
 
-#ifdef USE_GCONF
   if (download_proxy_gconf)
     {
       gchar *proxy;
       gint port;
       gchar *user;
       gchar *password;
-      GSList *list, *l;
+      gchar **list;
+      guint i;
       gboolean ignore = FALSE;
 
       if (morla_gconf_proxy (&proxy, &port, &user, &password, &list) == TRUE)
 	{
-	  for (l = list; l; l = l->next)
+	  for (i = 0; i < g_strv_length (list); i++)
 	    {
-	      if (g_str_has_prefix (uri, l->data) == TRUE)
+	      if (g_str_has_prefix (uri, list[i]) == TRUE)
 		{
 		  ignore = TRUE;
 		  break;
@@ -116,7 +114,6 @@
 	}
     }
   else
-#endif
 
     /* Valori di default: */
   if (download_proxy)
--- morla-0.16.1.orig/src/editor.h
+++ morla-0.16.1/src/editor.h
@@ -53,10 +53,6 @@
 #  endif
 #endif
 
-#ifdef USE_GCONF
-#  include <gconf/gconf-client.h>
-#endif
-
 #include "morla-module.h"
 
 struct module_t
@@ -483,9 +479,7 @@
 
 extern gchar *download_proxy;
 
-#ifdef USE_GCONF
 extern gboolean download_proxy_gconf;
-#endif
 
 extern gint download_proxy_port;
 extern gchar *download_proxy_user;
@@ -1012,7 +1006,7 @@
 					 gint *		port,
 					 gchar **	user,
 					 gchar **	password,
-					 GSList **	list);
+					 gchar ***	list);
 
 void		morla_gconf_shutdown	(void);
 
--- morla-0.16.1.orig/src/gconf.c
+++ morla-0.16.1/src/gconf.c
@@ -24,40 +24,38 @@
 
 #include "editor.h"
 
-#ifdef USE_GCONF
+#define GCONF_PROXY_SERVER_KEY		"host"
+#define GCONF_PROXY_PORT_KEY		"port"
+#define GCONF_PROXY_USER_KEY		"authentication-user"
+#define GCONF_PROXY_PASSWORD_KEY 	"authentication-password"
+#define GCONF_PROXY_IGNORE_KEY		"ignore-hosts"
 
-#define GCONF_PROXY_NS			"/system/http_proxy"
-#define GCONF_PROXY_KEY			GCONF_PROXY_NS "/use_http_proxy"
-#define GCONF_PROXY_SERVER_KEY		GCONF_PROXY_NS "/host"
-#define GCONF_PROXY_PORT_KEY		GCONF_PROXY_NS "/port"
-#define GCONF_PROXY_USER_KEY		GCONF_PROXY_NS "/authentication_user"
-#define GCONF_PROXY_PASSWORD_KEY 	GCONF_PROXY_NS "/authentication_password"
-#define GCONF_PROXY_IGNORE_KEY		GCONF_PROXY_NS "/ignore_hosts"
-
-static GConfClient *morla_gcc = NULL;
+static GSettings *morla_gcc = NULL;
+static GSettings *morla_gcc_http = NULL;
 
 static gboolean morla_proxy_enable = FALSE;
 static gchar *morla_proxy = NULL;
 static gint morla_proxy_port = 0;
 static gchar *morla_proxy_user = NULL;
 static gchar *morla_proxy_password = NULL;
-static GSList *morla_proxy_ignore_list = NULL;
+static gchar **morla_proxy_ignore_list = NULL;
 
 static void morla_gconf_refresh (void);
-static void morla_gconf_refresh_single (GConfClient * client, guint id,
-					GConfEntry * entry, gpointer dummy);
+static void morla_gconf_refresh_single (GSettings *settings, gchar *key,
+					gpointer dummy);
 static void morla_gconf_free (void);
 
 void
 morla_gconf_init (void)
 {
-  g_type_init ();
-
-  morla_gcc = gconf_client_get_default ();
+  morla_gcc = g_settings_new ("org.gnome.system.proxy");
+  morla_gcc_http = g_settings_get_child (morla_gcc, "http");
 
   morla_gconf_refresh ();
-  gconf_client_notify_add (morla_gcc, GCONF_PROXY_NS,
-			   morla_gconf_refresh_single, NULL, NULL, NULL);
+  g_signal_connect (morla_gcc, "changed",
+                    G_CALLBACK (morla_gconf_refresh_single), NULL);
+  g_signal_connect (morla_gcc_http, "changed",
+                    G_CALLBACK (morla_gconf_refresh_single), NULL);
 }
 
 static void
@@ -73,10 +71,7 @@
     g_free (morla_proxy_password);
 
   if (morla_proxy_ignore_list)
-    {
-      g_slist_foreach (morla_proxy_ignore_list, (GFunc) g_free, NULL);
-      g_slist_free (morla_proxy_ignore_list);
-    }
+    g_strfreev (morla_proxy_ignore_list);
 }
 
 static void
@@ -84,101 +79,77 @@
 {
   morla_gconf_free ();
 
-  morla_proxy_enable =
-    gconf_client_get_bool (morla_gcc, GCONF_PROXY_KEY, NULL);
-
   morla_proxy =
-    gconf_client_get_string (morla_gcc, GCONF_PROXY_SERVER_KEY, NULL);
+    g_settings_get_string (morla_gcc_http, GCONF_PROXY_SERVER_KEY);
 
   morla_proxy_port =
-    gconf_client_get_int (morla_gcc, GCONF_PROXY_PORT_KEY, NULL);
+    g_settings_get_int (morla_gcc_http, GCONF_PROXY_PORT_KEY);
+
+  morla_proxy_enable = (gboolean) (strlen (morla_proxy) && morla_proxy_port);
 
   morla_proxy_user =
-    gconf_client_get_string (morla_gcc, GCONF_PROXY_USER_KEY, NULL);
+    g_settings_get_string (morla_gcc_http, GCONF_PROXY_USER_KEY);
 
   morla_proxy_password =
-    gconf_client_get_string (morla_gcc, GCONF_PROXY_PASSWORD_KEY, NULL);
+    g_settings_get_string (morla_gcc_http, GCONF_PROXY_PASSWORD_KEY);
 
   morla_proxy_ignore_list =
-    gconf_client_get_list (morla_gcc, GCONF_PROXY_IGNORE_KEY,
-			   GCONF_VALUE_STRING, NULL);
+    g_settings_get_strv (morla_gcc, GCONF_PROXY_IGNORE_KEY);
 }
 
 static void
-morla_gconf_refresh_single (GConfClient * client, guint id,
-			    GConfEntry * entry, gpointer dummy)
+morla_gconf_refresh_single (GSettings * settings, gchar * key, gpointer dummy)
 {
-  GConfValue *value;
-
-  if (!entry || !entry->key)
-    return;
-
-  value = gconf_entry_get_value (entry);
-
-  if (!strcmp (entry->key, GCONF_PROXY_KEY))
-    morla_proxy_enable = gconf_value_get_bool (value);
-
-  else if (!strcmp (entry->key, GCONF_PROXY_SERVER_KEY))
+  if (!strcmp (key, GCONF_PROXY_SERVER_KEY))
     {
       if (morla_proxy)
 	g_free (morla_proxy);
 
-      if ((morla_proxy = (gchar *) gconf_value_get_string (value)))
-	morla_proxy = g_strdup (morla_proxy);
+      morla_proxy = g_settings_get_string (settings, key);
     }
 
-  else if (!strcmp (entry->key, GCONF_PROXY_PORT_KEY))
-    morla_proxy_port = gconf_value_get_int (value);
+  else if (!strcmp (key, GCONF_PROXY_PORT_KEY))
+    morla_proxy_port = g_settings_get_int (settings, key);
 
-  else if (!strcmp (entry->key, GCONF_PROXY_USER_KEY))
+  else if (!strcmp (key, GCONF_PROXY_USER_KEY))
     {
       if (morla_proxy_user)
 	g_free (morla_proxy_user);
 
-      if ((morla_proxy_user = (gchar *) gconf_value_get_string (value)))
-	morla_proxy_user = g_strdup (morla_proxy_user);
+      morla_proxy_user = g_settings_get_string (settings, key);
     }
 
-  else if (!strcmp (entry->key, GCONF_PROXY_PASSWORD_KEY))
+  else if (!strcmp (key, GCONF_PROXY_PASSWORD_KEY))
     {
       if (morla_proxy_password)
 	g_free (morla_proxy_password);
 
-      if ((morla_proxy_password = (gchar *) gconf_value_get_string (value)))
-	morla_proxy_password = g_strdup (morla_proxy_password);
+      morla_proxy_password = g_settings_get_string (settings, key);
     }
 
-  else if (!strcmp (entry->key, GCONF_PROXY_IGNORE_KEY))
+  else if (!strcmp (key, GCONF_PROXY_IGNORE_KEY))
     {
       if (morla_proxy_ignore_list)
-	{
-	  g_slist_foreach (morla_proxy_ignore_list, (GFunc) g_free, NULL);
-	  g_slist_free (morla_proxy_ignore_list);
-	}
-
-      if ((morla_proxy_ignore_list = gconf_value_get_list (value)))
-	{
-	  GSList *l;
-
-	  morla_proxy_ignore_list = g_slist_copy (morla_proxy_ignore_list);
-
-	  for (l = morla_proxy_ignore_list; l; l = l->next)
-	    l->data = g_strdup (l->data);
-	}
+        g_strfreev (morla_proxy_ignore_list);
+
+      morla_proxy_ignore_list = g_settings_get_strv (settings, key);
     }
+
+  morla_proxy_enable = (gboolean) (strlen (morla_proxy) && morla_proxy_port);
 }
 
 void
 morla_gconf_shutdown (void)
 {
   g_object_unref (morla_gcc);
+  g_object_unref (morla_gcc_http);
 
   morla_gconf_free ();
 }
 
 gboolean
 morla_gconf_proxy (gchar ** proxy, gint * port, gchar ** user,
-		   gchar ** password, GSList ** list)
+		   gchar ** password, gchar *** list)
 {
   if (morla_proxy_enable == FALSE)
     return FALSE;
@@ -191,6 +162,4 @@
   return TRUE;
 }
 
-#endif
-
 /* EOF */
--- morla-0.16.1.orig/src/init.c
+++ morla-0.16.1/src/init.c
@@ -383,13 +383,11 @@
 	{
 	  nxml_attr_t *attr;
 
-#ifdef USE_GCONF
 	  if (nxml_find_attribute (data, "gconf", &attr) == NXML_OK && attr
 	      && !strcmp (attr->value, "true"))
 	    download_proxy_gconf = TRUE;
 	  else
 	    download_proxy_gconf = FALSE;
-#endif
 
 	  if (nxml_find_attribute (data, "server", &attr) == NXML_OK && attr)
 	    download_proxy = g_strdup (attr->value);
@@ -688,9 +686,7 @@
 
   fprintf (fl, "  <proxy");
 
-#ifdef USE_GCONF
   fprintf (fl, " gconf=\"%s\"", download_proxy_gconf ? "true" : "false");
-#endif
 
   if (download_proxy)
     fprintf (fl, " server=\"%s\"", download_proxy);
--- morla-0.16.1.orig/src/main.c
+++ morla-0.16.1/src/main.c
@@ -306,9 +306,7 @@
 
   gtk_window_set_default_icon_from_file (main_path_icon (), NULL);
 
-#ifdef USE_GCONF
   morla_gconf_init ();
-#endif
 
   init (m_config);
 
@@ -1200,9 +1198,7 @@
 
   gtk_main ();
 
-#ifdef USE_GCONF
   morla_gconf_shutdown ();
-#endif
 
   module_shutdown ();
   return 0;
--- morla-0.16.1.orig/src/preferences.c
+++ morla-0.16.1/src/preferences.c
@@ -72,10 +72,8 @@
 static void preferences_highlighting_demo (GtkWidget *, struct tag_t *tag);
 static void preferences_highlighting_reset (GtkWidget * w,
 					    GtkWidget * treeview);
-#ifdef USE_GCONF
 static void preferences_proxy (GtkWidget * w, GtkWidget * hbox);
 static void preferences_proxy_gconf (GtkWidget * w, GtkWidget * proxy);
-#endif
 
 /* Questa funzione configura le preferenze */
 void
@@ -112,9 +110,7 @@
   gchar s[1024];
 
   GtkWidget *proxy;
-#ifdef USE_GCONF
   GtkWidget *proxy_gconf;
-#endif
   GtkWidget *proxy_server;
   GtkWidget *proxy_port;
   GtkWidget *proxy_user;
@@ -1220,27 +1216,18 @@
   hbox = gtk_hbox_new (TRUE, 5);
   gtk_container_add (GTK_CONTAINER (frame), hbox);
 
-#ifdef USE_GCONF
   proxy_gconf = gtk_check_button_new ();
   g_object_set_data (G_OBJECT (proxy), "gconf", proxy_gconf);
 
   g_signal_connect_after ((gpointer) proxy, "toggled",
 			  G_CALLBACK (preferences_proxy), hbox);
-#else
-  g_signal_connect_after ((gpointer) proxy, "toggled",
-			  G_CALLBACK (preferences_switch), hbox);
-#endif
 
   if (!download_proxy)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (proxy), FALSE);
   else
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (proxy), TRUE);
 
-#ifdef USE_GCONF
   preferences_proxy (proxy, hbox);
-#else
-  preferences_switch (proxy, hbox);
-#endif
 
   vbox = gtk_vbox_new (TRUE, 5);
   gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
@@ -1291,7 +1278,6 @@
     gtk_entry_set_text (GTK_ENTRY (proxy_password), download_proxy_password);
   gtk_box_pack_start (GTK_BOX (box), proxy_password, TRUE, TRUE, 0);
 
-#ifdef USE_GCONF
   frame = gtk_frame_new (_("Gnome"));
   gtk_box_pack_start (GTK_BOX (gbox), frame, FALSE, FALSE, 0);
 
@@ -1307,7 +1293,6 @@
 
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (proxy_gconf),
 				download_proxy_gconf);
-#endif
 
   /* HIGHLIGHTING */
 
@@ -2250,10 +2235,8 @@
 	}
 
       /* NETWORK */
-#ifdef USE_GCONF
       download_proxy_gconf =
 	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (proxy_gconf));
-#endif
 
       if (!(tmp = (gchar *) gtk_entry_get_text (GTK_ENTRY (proxy_server)))
 	  || !*tmp)
@@ -3475,7 +3458,6 @@
   g_list_free (def);
 }
 
-#ifdef USE_GCONF
 static void
 preferences_proxy (GtkWidget * w, GtkWidget * box)
 {
@@ -3496,6 +3478,5 @@
   if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (w)))
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (proxy), FALSE);
 }
-#endif
 
 /* EOF */
